/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.applet.Applet;
import java.awt.*;

public class VasTabKey extends Applet {
  Label l1;
  TextField t1;
  Button b1, b2;
  TextArea ta1;
  Checkbox ck1;
  Choice ch1;
  List ls1;
  //to move from one TextField to another using tabkey
  public Component[] compo;

  public String getAppletInfo() {
    return (new String("VasTabKey v1.3 September 5th, 1998, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }

  //constructor
  public VasTabKey() {
    setLayout(null);
    setBackground(Color.lightGray);
    //putting some controls in the applet
    l1=new Label("Use TabKey/shift+TabKey to pass trought fields");
    l1.reshape(5, 10, 280, 25);
    add(l1);
    t1=new TextField("text1");
    t1.reshape(10, 40, 80, 25);
    add(t1);
    ch1=new Choice();
    ch1.addItem("Option1");
    ch1.addItem("Option2");
    add(ch1);
    b1=new Button("Button1");
    b1.reshape(210, 40, 70, 30);
    add(b1);
    b2=new Button("Button2");
    b2.reshape(10, 80, 70, 30);
    add(b2);
    ls1=new List();
    ls1.addItem("Option1");
    ls1.addItem("Option2");
    add(ls1);
    ck1=new Checkbox("Check1");
    ck1.reshape(210, 80, 80, 30);
    add(ck1);
    ta1=new TextArea();
    ta1.reshape(10, 150, 270, 130);
    ta1.setEditable(false);
    add(ta1);
   
    ta1.appendText("It is an applet which allows you to pass");
    ta1.appendText("\nfrom a component to another using the");
    ta1.appendText("\nTabKey and shift+TabKey to go back. It");
    ta1.appendText("\nwill also execute an action when you hit");
    ta1.appendText("\nReturnKey when the focus is on a Button.");
    ta1.appendText("\n(C) 1997, 1998, 1999, 2000 Vasile Calmatui");
    resize(290, 290);
  }//end constructor

  public void init() {
    //we have to reshape the list and the choice in the init
    ch1.reshape(100, 40, 100, 25);
    ls1.reshape(100, 80, 100, 60);
    //to move from one TextField to another using tabkey
    compo=new Component[7];
    compo[0]=t1;
    compo[1]=ch1;
    compo[2]=b1;
    compo[3]=b2;
    compo[4]=ls1;
    compo[5]=ck1;
    compo[6]=ta1;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//end init

  public boolean handleEvent(Event e) {
    //to move from one TextField to another using tabkey
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //in IE4, the text remains selected
          //it's not cute, so deselect it before going away
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //if a component is disabled, we go further
          //thanks:-) Jean-Marie GANDON
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while(!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }
      }
      return false;
    }//end '\t'

    //if return hit, it will go
    if(e.target==b1 && (e.arg==b1.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(b2.isEnabled()) b2.disable();
      else b2.enable();
      return true;
    }//end b1

    //if ReturKey hit, it will go
    if(e.target==b2 && (e.arg==b2.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      if(b1.isEnabled()) b1.disable();
      else b1.enable();
      return true;
    }//end b2
    return false;//other events won't be analyzed
  }//end handleEvent
}//end class VasTabKey
